#! /usr/bin/perl

open(FILE,$ARGV[0]) || die "File non trovato ...";
#
# Notare che l'assegnazione a $_  implicita solo in cicli while, for e 
# foreach, non altrimenti. "<FILE>;"  senza l'assegnamento esplicito a $_ non funziona
#
$_ = <FILE>;
close FILE;

# Ultime tre righe equivalenti al seguente qx
#
# $_ = qx{[ -e $ARGV[0] ] && cat $ARGV[0]} || die "File non trovato ...";
#
# il comando lanciato da qx consiste in un test sull'esistenza del file: [ -e $ARGV[0] ]
# in and: &&
# con il comando cat sul file: cat $ARGV[0]
# Per cui se il file esiste viene eseguito il comando cat e in $_ viene memorizzata la prima righa del file
# altrimenti viene restituito 'false' ed eseguito il comando die che stampa "File non trovato ..."

#
# Qui invece l'oggetto del confronto  implicitamente $_
#
/(\w+) (\w+) ([0-9]+)/;
#
# Assegnazione multipla di tre variabili.
#
( $cognome, $nome, $matricola ) = ($1,$2, $3);

# I due metodi che seguono sono equivalenti alle due righe precedenti
#
# METODO 1
#    ($cognome, $nome, $matricola) = split (' ');
#
# METODO 2
#    @pezzi = split(' ');
#    $cognome = $pezzi[0];
#    $nome = $pezzi[1];
#    $matricola = $pezzi[2];

###print "\n" . $matricola . "--\n";
###exit 1;

#
# lc ritorna la versione lowercase di una variabile. Non prevede
# assegnamenti impliciti a $_, come anche 'uc'.
#
$nome = lc $nome;
qx{mkdir $nome};
$cognome = uc $cognome;
qx{mkdir $cognome};

#
# Split su espressione regolare vuota corrisponde a split su ogni 
# carattere.
#
@cifre = split //, $matricola;

foreach $cifra (@cifre)
{
	$i++;
	$directory = 
		($cifra % 2) ? $cognome : $nome; 

# Crea i file nella $directory corretta e inserisce $cifra
    open(FILE,">$directory\/$i.txt");
    print FILE $cifra;
    close FILE;
#
# Ultime tre righe equivalenti alla seguente qx{}.
#   
# qx{echo $cifra >$directory\$i.txt};

}

# Stampa il percorso completo alla directory corrente
# (quella in cui  stata creata la struttura dati)
print qx{pwd};


